<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>DB DRAWER</title>
    <link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900|Material+Icons" rel="stylesheet"
          type="text/css">
    <link href="https://cdn.jsdelivr.net/npm/quasar@1.15.10/dist/quasar.min.css" rel="stylesheet" type="text/css">
    <link href="assets/css/app.css" rel="stylesheet" type="text/css">
</head>
<body>
<div id="db-drawer">
    <div class="relation-line" v-bind:style="lineStyles" v-if="typeof startRelation.index !== 'undefined'"></div>
    <div class="q-pa-md">
        <div class="row">
            <div class="col-12">
                <q-btn round color="black" icon="table_chart" @click="addTable" draggable="true"></q-btn>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-9 q-pa-md">
            <div class="tables" @mousemove="drag" @click="isDrag = false" ref="dragContainer">
                <div class="draggable" v-for="(table, index) in tables"
                     @mousedown="initDrag($event, index)"
                     @mouseup="dragStop($event, index)"
                     @contextmenu.stop.prevent="cancelDrag"
                     :style="{top:table.y + 'px',left:table.x + 'px', width: '120px'}">
                    <q-table
                            :data="table.columns"
                            :title="table.title"
                            :columns="columns"
                            hide-header
                            hide-bottom
                            dense
                            row-key="name"
                            :rows-per-page-options="[0]"
                            :class="currentTable === index && selectedTable ? 'selected' : ''"
                            title-class="q-table-title">
                        <template v-slot:body="props">
                            <q-tr v-if="typeof props.row !== 'undefined'" :props="props"
                                  @click="showSettings(index, props.row.id)"
                                  :class="typeof tables[currentTable].columns[currentColumn] !== 'undefined' && tables[currentTable].columns[currentColumn].id === props.row.id ? 'selected' : ''">
                                <q-td key="name" :props="props">
                                    {{ props.row.name }}
                                </q-td>
                            </q-tr>
                        </template>
                    </q-table>
                    <div class="add-relation has-many" @click="initRelation(index, true)"></div>
                    <div class="add-relation belong-to" @click="initRelation(index, false)"></div>
                    <div class="relation-table">

                    </div>
                    <div v-for="(relation, relationIndex) in table.relations"
                         :class="selectedRelation.length > 0 && selectedRelation[0] === index && selectedRelation[1] === relationIndex ? relation.classes + ' relation selected' : relation.classes + ' relation'"
                         @click="selectedRelation = [index, relationIndex]"
                         v-bind:style="{top: relation.t, bottom: relation.b, left: relation.l, right: relation.r, width: relation.w, height: relation.h}"></div>
                </div>
            </div>
        </div>
        <div class="col-3 q-pa-md">
            <div class="table-settings" v-if="typeof tables[currentTable] !== 'undefined' && typeof tables[currentTable].columns[currentColumn] !== 'undefined'">
                <h3 v-html="tables[currentTable].title + ' settings'"></h3>
                <div class="q-pa-sm">
                    <q-input v-model="tables[currentTable].title" label="Table Name" placeholder="Table Name" />
                </div>
                <div class="q-pa-sm">
                    <q-input v-model="tables[currentTable].columns[currentColumn].name" label="Column Name" placeholder="Column name" />
                </div>
                <div class="q-gutter-sm">
                    <q-btn color="primary" label="Add Column" size="sm" @click="addColumn()"></q-btn>
                    <q-btn color="primary" label="remove Column" size="sm" @click="removeColumn()"></q-btn>
                </div>
                <div class="q-pa-sm">
                    <q-select v-model="tables[currentTable].columns[currentColumn].type" :options="columnTypes" label="Column type" />
                </div>
                <div class="q-pa-sm" v-for="attribute in columnAttributes">
                    <q-checkbox v-model="tables[currentTable].columns[currentColumn].attributes[attribute.id]" :label="attribute.label" @input="changeAttr($event, attribute.id, attribute.single)" />
                </div>
            </div>
        </div>
    </div>
</div>
<script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
<script src="https://cdn.jsdelivr.net/npm/quasar@1.15.10/dist/quasar.umd.min.js"></script>
<script src="assets/js/app.js"></script>
</body>
</html>